/*
Dataddo Headless BETA API

Dataddo Headless BETA API

API version: 1.0.0-beta.1
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package customer_api

import (
	"encoding/json"
)

// checks if the PanoplyDestinationAllOf type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &PanoplyDestinationAllOf{}

// PanoplyDestinationAllOf struct for PanoplyDestinationAllOf
type PanoplyDestinationAllOf struct {
	OAuthId   *int32  `json:"o_auth_id,omitempty"`
	ProjectId *string `json:"project_id,omitempty"`
	DatasetId *string `json:"dataset_id,omitempty"`
}

// NewPanoplyDestinationAllOf instantiates a new PanoplyDestinationAllOf object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewPanoplyDestinationAllOf() *PanoplyDestinationAllOf {
	this := PanoplyDestinationAllOf{}
	return &this
}

// NewPanoplyDestinationAllOfWithDefaults instantiates a new PanoplyDestinationAllOf object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewPanoplyDestinationAllOfWithDefaults() *PanoplyDestinationAllOf {
	this := PanoplyDestinationAllOf{}
	return &this
}

// GetOAuthId returns the OAuthId field value if set, zero value otherwise.
func (o *PanoplyDestinationAllOf) GetOAuthId() int32 {
	if o == nil || IsNil(o.OAuthId) {
		var ret int32
		return ret
	}
	return *o.OAuthId
}

// GetOAuthIdOk returns a tuple with the OAuthId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *PanoplyDestinationAllOf) GetOAuthIdOk() (*int32, bool) {
	if o == nil || IsNil(o.OAuthId) {
		return nil, false
	}
	return o.OAuthId, true
}

// HasOAuthId returns a boolean if a field has been set.
func (o *PanoplyDestinationAllOf) HasOAuthId() bool {
	if o != nil && !IsNil(o.OAuthId) {
		return true
	}

	return false
}

// SetOAuthId gets a reference to the given int32 and assigns it to the OAuthId field.
func (o *PanoplyDestinationAllOf) SetOAuthId(v int32) {
	o.OAuthId = &v
}

// GetProjectId returns the ProjectId field value if set, zero value otherwise.
func (o *PanoplyDestinationAllOf) GetProjectId() string {
	if o == nil || IsNil(o.ProjectId) {
		var ret string
		return ret
	}
	return *o.ProjectId
}

// GetProjectIdOk returns a tuple with the ProjectId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *PanoplyDestinationAllOf) GetProjectIdOk() (*string, bool) {
	if o == nil || IsNil(o.ProjectId) {
		return nil, false
	}
	return o.ProjectId, true
}

// HasProjectId returns a boolean if a field has been set.
func (o *PanoplyDestinationAllOf) HasProjectId() bool {
	if o != nil && !IsNil(o.ProjectId) {
		return true
	}

	return false
}

// SetProjectId gets a reference to the given string and assigns it to the ProjectId field.
func (o *PanoplyDestinationAllOf) SetProjectId(v string) {
	o.ProjectId = &v
}

// GetDatasetId returns the DatasetId field value if set, zero value otherwise.
func (o *PanoplyDestinationAllOf) GetDatasetId() string {
	if o == nil || IsNil(o.DatasetId) {
		var ret string
		return ret
	}
	return *o.DatasetId
}

// GetDatasetIdOk returns a tuple with the DatasetId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *PanoplyDestinationAllOf) GetDatasetIdOk() (*string, bool) {
	if o == nil || IsNil(o.DatasetId) {
		return nil, false
	}
	return o.DatasetId, true
}

// HasDatasetId returns a boolean if a field has been set.
func (o *PanoplyDestinationAllOf) HasDatasetId() bool {
	if o != nil && !IsNil(o.DatasetId) {
		return true
	}

	return false
}

// SetDatasetId gets a reference to the given string and assigns it to the DatasetId field.
func (o *PanoplyDestinationAllOf) SetDatasetId(v string) {
	o.DatasetId = &v
}

func (o PanoplyDestinationAllOf) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o PanoplyDestinationAllOf) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.OAuthId) {
		toSerialize["o_auth_id"] = o.OAuthId
	}
	if !IsNil(o.ProjectId) {
		toSerialize["project_id"] = o.ProjectId
	}
	if !IsNil(o.DatasetId) {
		toSerialize["dataset_id"] = o.DatasetId
	}
	return toSerialize, nil
}

type NullablePanoplyDestinationAllOf struct {
	value *PanoplyDestinationAllOf
	isSet bool
}

func (v NullablePanoplyDestinationAllOf) Get() *PanoplyDestinationAllOf {
	return v.value
}

func (v *NullablePanoplyDestinationAllOf) Set(val *PanoplyDestinationAllOf) {
	v.value = val
	v.isSet = true
}

func (v NullablePanoplyDestinationAllOf) IsSet() bool {
	return v.isSet
}

func (v *NullablePanoplyDestinationAllOf) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullablePanoplyDestinationAllOf(val *PanoplyDestinationAllOf) *NullablePanoplyDestinationAllOf {
	return &NullablePanoplyDestinationAllOf{value: val, isSet: true}
}

func (v NullablePanoplyDestinationAllOf) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullablePanoplyDestinationAllOf) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
